from pyloadl import *
from sys import exit

"""

   Displays information similar to llstatus -B command

"""

partitionStateString = [ "FREE", "CFG", "READY", "BUSY",
                         "DEALC", "ERROR", "NAV" ]

bpStateString= [ "UP", "DOWN", "MISSING", "ERROR", "NAV" ]

# Query Blue Gene information

query = ll_query(BLUE_GENE)
if not PyCObjValid(query):
   print "ll_query(): returns NULL\n"
   exit(-1)

retval = ll_set_request(query, QUERY_BG_BASE_PARTITION, ["All"], ALL_DATA)
if retval != 0:
   print "ll_set_request(): error %d\n" % retval
   exit(-1)

# Get the machine objects from the LoadL_negotiator (central manager) daemon

machine, obj_count, err_code = ll_get_objs(query, LL_CM, "")
if err_code != 0:
    print "Query MACHINES: ll_get_objs() returns NULL. Error code =  %d" % err_code
    exit(-1)

bp = ll_get_data(machine, LL_BgMachineGetFirstBP)
while PyCObjValid(bp):
    BP_id = ll_get_data(bp, LL_BgBPId)
    print "Base Partition Id: %s" % BP_id

    state = ll_get_data(bp, LL_BgBPState)
    status = bpStateString[state]
    print "\tBase Partition State: %s" % status

    size = []
    size = ll_get_data(bp, LL_BgBPLocation)
    print "\tLocation: (%s)" % size

    Busy = ll_get_data(bp, LL_BgBPSubDividedBusy)
    print "\tSub Divided Busy: %s" % Busy

    partition = ll_get_data(bp, LL_BgBPCurrentPartition)

    partition_state = ll_get_data(bp, LL_BgBPCurrentPartitionState)

    if len(partition) == 0:
       partid = "NONE"
       partstate = "NONE"
    else:
       partid = partition
       partstate = partitionStateString[partition_state]

    print "\tPartitionState=%s Partition=%s" % (partstate, partid)
    print

    bp = ll_get_data(machine, LL_BgMachineGetNextBP)

