from pyloadl import *
from sys import exit

"""

   Displays information similar to llstatus -b

"""

# Query Blue Gene information

query = ll_query(BLUE_GENE)
if not PyCObjValid(query):
   print "ll_query(): returns NULL\n"
   exit(-1)

retval = ll_set_request(query, QUERY_BG_BASE_PARTITION, ["All"], ALL_DATA)
if retval != 0:
   print "ll_set_request(): error %d\n" % retval
   exit(-1)

# Get the machine objects from the LoadL_negotiator (central manager) daemon

machine, obj_count, err_code = ll_get_objs(query, LL_CM, "")
if err_code != 0:
    print "Query MACHINES: ll_get_objs() returns NULL. Error code =  %d" % err_code
    exit(-1)

BG_size = []
BG_size = ll_get_data(machine, LL_BgMachineSize)
if len(BG_size) > 0:
  mach_bg_size = "%sx%sx%s" % (BG_size[0], BG_size[1], BG_size[2])

BP_size = []
BP_size = ll_get_data(machine, LL_BgMachineBPSize)
if len(BP_size) > 0:
   mach_bp_size = "%sx%sx%s" % (BP_size[0], BP_size[1], BP_size[2])

c_nodes = [0,0,0]
c_nodes[0] = BG_size[0]*BP_size[0]
c_nodes[1] = BG_size[1]*BP_size[1]
c_nodes[2] = BG_size[2]*BP_size[2]
cnodes = "%sx%sx%s" % (c_nodes[0], c_nodes[1], c_nodes[2])

ll_free_objs(query)
ll_deallocate(query)

# Query Blue Gene Job information

query = ll_query(JOBS)
if not PyCObjValid(query):
   print "ll_query(): returns NULL\n"
   exit(-1)

retval = ll_set_request(query, QUERY_BG_JOB, "", ALL_DATA)
if retval != 0:
   print "ll_set_request(): error %d\n" % retval
   exit(-1)

run = 0
job, num, err = ll_get_objs(query, LL_CM, "")
if err != 0:
   print "ll_get_objs(): error %d" % err
   exit(-1)

if num > 0:

   while PyCObjValid(job):

      # Loop through all steps for this job

      step = ll_get_data(job, LL_JobGetFirstStep)
      while PyCObjValid(step):

        stepstate = ll_get_data(step,  LL_StepState)
        if stepstate == STATE_RUNNING:
          run = run + 1
        step = ll_get_data(job, LL_JobGetNextStep)

      job = ll_next_obj(query)

# Free and deallocate objects used by LoadLeveler

ll_free_objs(query)
ll_deallocate(query)

name = "BGL"

print "Name          Base Partitions  c-nodes    InQ    Run"
print "%-10s %10s %15s %7s %6s" % (name, mach_bg_size, cnodes, num, run)

